<template>
  <div v-if="promotion" class="promotion-detail-modal">
    <button class="title__back-link" @click="() => [$emit('close'), $router.push('/promotion')]">
      <font-awesome-icon icon="arrow-right" class="mr-2 back-icon" />
      {{ $t("back") }}
    </button>
    <div class="promotion-info__wrapper">
      <div class="promotion-info">
        <h1 class="page__title">{{ promotion.Title }}</h1>
        <el-image
          class="promotion-info__image"
          :src="promotion.ImagePathForDisplay"
          lazy
        >
          <template #error>
            <div class="h-full bg-[var(--background1)]">
              <img
                :src="getAssetImage('assets/theme/common/game/NoImage.png')"
              />
            </div> </template
        ></el-image>

        <div
          class="promotion-info__description"
          v-html="promotion.Content"
        ></div>
      </div>
      <div class="promotion-info__right">
        <div class="promotion-info__stat">
          <div class="promotion-stat__item">
            {{ $t("start_date") }}
            <div class="promotion-stat__value">
              {{ promotion.StartDateForDisplay }}
            </div>
          </div>
          <div class="promotion-stat__item">
            {{ $t("end_date") }}
            <div class="promotion-stat__value">
              {{ promotion.EndDateForDisplay }}
            </div>
          </div>
          <nuxt-link
            v-if="
              !isLoggedIn &&
              buttonApplyPromotionEnabled(promotion) &&
              !register.IsHidden
            "
            to="/register"
            class="w-full"
          >
            <Button variant="Accent" class="apply-button">{{
              $t("register_for_promotion")
            }}</Button>
          </nuxt-link>
          <el-button
            v-if="validateLuckyWheelbutton(promotion)"
            class="apply-button"
            @click="onClickSpinNow"
            :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
          >
            <Button variant="Accent" class="apply-button">{{
              $t("Spin Now")
            }}</Button>
          </el-button>
          <el-button
            v-else-if="isLoggedIn && buttonApplyPromotionEnabled(promotion)"
            class="apply-button"
            :disabled="isProcessing"
            @click="promotion && onApplyPromotion(promotion)"
            :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
          >
            <Button variant="Accent" class="apply-button">{{
              $t("apply")
            }}</Button>
          </el-button>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { computed } from "vue";
import Button from "../ui/Button.client.vue";
import { Promotion } from "@/models/promotion/promotion";
import commonHelper from "@/utils/commonHelper";
import { store } from "@/store";
import themePropertyHelper from "@/utils/themePropertyHelper";
import {ID} from "~~/utils/constants";
const {
  onApplyPromotion,
  isProcessing,
  buttonApplyPromotionEnabled,
  validateLuckyWheelbutton,
} = usePromotion();
const isLoggedIn = computed(() => store.state.auth);
const register = computed(() =>
  themePropertyHelper.getSingleThemeProperty(
    store.state.companyThemePropertiesFromApi.ThemeProperties,
    "register"
  )
);
const { getAssetImage } = commonHelper;
defineProps({
  promotion: {
    type: Object as PropType<Promotion>,
  },
  onClickSpinNow: {
    type: Function,
    required: true,
  },
});
defineEmits(["close"]);

const scrollToTop = () => {
  window.scrollTo({ top: 0 });
};

scrollToTop();
</script>

<style lang="scss" scoped>
.apply-button {
  width: 100% !important;
  padding: 0 !important;
}
:deep(.apply-button span) {
  display: block;
  width: 100%;
  pointer-events: none;
}
.promotion-detail-modal {
  @apply relative w-full h-full z-[5];
  color: var(--font-color-primary);
  background: var(--background2);
}

.title__back-link {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  text-decoration: none !important;
  color: var(--text);
  margin-bottom: 16px;
  font-size: 16px;
  font-weight: 600;
  text-transform: uppercase;
}
.title__back-link .back-icon {
  font-size: 18px;
  transform: rotate(180deg);
}
.title__back-link:hover {
  color: var(--text2);
}
@media (max-width: 767px) {
  .title__back-link {
    font-size: 12px;
    line-height: 16px;
  }
}
.promotion-info__wrapper {
  display: flex;
  align-items: flex-start;
  gap: 2rem;
  padding-top: 16px;
  padding-bottom: 40px;
}
@media (max-width: 980px) {
  .promotion-info__wrapper {
    flex-direction: column;
  }
}
.promotion-info {
  max-width: 872px;
  width: 100%;
}
@media (max-width: 980px) {
  .promotion-info {
    max-width: 100%;
  }
}
@media (max-width: 1220px) {
  .promotion-info {
    max-width: 612px;
  }
}
@media (max-width: 1440px), (orientation: portrait) {
  .promotion-info {
    max-width: 736px;
  }
}
.page__title {
  width: auto;
  margin: 0;
  font-size: 44px;
  line-height: 52px;
  font-style: normal;
  font-weight: 700;
  -webkit-transition: color 0.4s;
  transition: color 0.4s;
  color: var(--title-font-color);
}
.promotion-info .page__title {
  margin-bottom: 8px;
}
@media (max-width: 767px) {
  .page__title {
    font-size: 24px;
    line-height: 32px;
  }
}
.promotion-info__image {
  width: 100%;
  margin-top: 16px;
  margin-bottom: 40px;
  position: relative;
  border-radius: 16px;
  overflow: hidden;
}
.promotion-info__image img {
  width: 100%;
}
.promotion-info__description {
  font-size: 20px;
  line-height: 34px;
}
.promotion-info__right {
  display: flex;
  gap: 0.25rem;
}
@media (max-width: 980px) {
  .promotion-info__right {
    width: 100%;
  }
}
@media (max-width: 1680px) {
  .promotion-info__right {
    flex-direction: column;
  }
}
.promotion-info__stat {
  box-shadow: var(--box-shadow);
  border-radius: 16px;
  padding: 40px;
  margin-left: 40px;
  width: 416px;
  display: flex;
  align-items: flex-start;
  flex-direction: column;
  gap: 1rem;
}
@media (max-width: 1440px), (orientation: portrait) {
  .promotion-info__stat {
    margin-left: 32px;
  }
}

@media (max-width: 980px) {
  .promotion-info__stat {
    margin-left: 0;
    width: 100%;
    padding: 24px 40px;
  }
}

@media (max-width: 640px) {
  .promotion-info__stat {
    padding: 24px;
  }
}
.promotion-stat__item {
  font-size: 12px;
  line-height: 18px;
  color: var(--text);
}
.promotion-stat__value {
  display: flex;
  align-items: center;
  margin-bottom: 0;
  font-size: 16px;
  color: var(--text);
  font-weight: 600;
}
</style>
